Subject: Re: [PATCH 3/3] USB: driver for Freescale QUICC Engine USBHost Controller

From: David Brownell <[email-masked]>
Date: Wed, 24 Sep 2008 11:59:03 -0700

On Wednesday 24 September 2008, Sergei Shtylyov wrote:
> 
> >>   ... then the root hub emulation is completely pointless.
> >>     
> >
> > It isn't. We always should emulate the root hub. The root hub
> > is part and parcel of any USB Host. Even the one-port one.
> 
>    Hm, maybe that's what USB core thinks (because UHCI/OHCI/EHCI all 
> have it) but e.g. MUSB doesn't have the root hub registers...

Only the OHCI registers have bit positions matching what the USB
spec says for hub status bits.  Everything else, including musb_hdrc,
has the relevant status encoded in other bits.

> I looked at the core and figured that USB core seems to use the root hub 
> interface for port PM, etc. and expects it to bee present, so it seems 
> unavoidable indeed... :-/

Or more fundamentally:  for enumeration.  "Unavoidable" is correct.  ;)